package org.nl.system.service.menu.dao.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.nl.system.service.menu.dao.SysMenu;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 菜单表 Mapper 接口
 * </p>
 *
 * @author ldjun
 * @since 2022-12-15
 */
public interface SysMenuMapper extends BaseMapper<SysMenu> {
    @Select("select * from sys_menu where (pid is null or pid = '' or pid = 0 )")
    List<SysMenu> findByPidIsNull();

    @Select("select * from sys_menu  where pid = #{pid}")
    List<SysMenu> findByPid(@Param("pid") String pid);

    /**
     * 根据用户获取菜单
     *
     * @param userId 用户标识
     * @return 当前用户拥有的菜单列表
     */
    List<SysMenu> findByUser(@Param("userId") String userId);

    /**
     * 获取系统菜单
     * @param userId
     * @param systemType
     * @return
     */
    List<SysMenu> findSystemMenu(@Param("user") String userId,@Param("systemType") String systemType);

    /**
     * 根据用户标识获取权限列表
     *
     * @param userId 用户标识
     * @return 权限列表
     */
    List<String> getPermissionByUserId(@Param("userId") String userId);

    /**
     * 解绑角色菜单
     *
     * @param menuId 菜单ID
     */
    @Delete(value = "delete from sys_roles_menus where menu_id = #{menuId}")
    void untiedMenu(String menuId);

    List<Map> getMenusByRole(@Param("systemType") String systemType, @Param("category")String category);

    String findAllChild(String pid);
}
